/* This file was generated by lv6 version master.737 (2727a7744111c84f7984634d2bd3ad6f7c6c7ff9). */
/*  lv6 -2c led.lus -n arduino_puzzle */
/* on estrop the 02/05/2018 at 11:14:43 */
#include "led_function.h"
//// Defining step functions
// Memory initialisation for Lustre_arrow_ctx
void Lustre_arrow_ctx_reset(Lustre_arrow_ctx_type* ctx){
  //int _i;
  ctx->_memory = _true;
}
// Memory allocation for Lustre_arrow_ctx
Lustre_arrow_ctx_type* Lustre_arrow_ctx_new_ctx(){

   Lustre_arrow_ctx_type* ctx = (Lustre_arrow_ctx_type*)calloc(1, sizeof(Lustre_arrow_ctx_type));
   // ctx->client_data = cdata;
   Lustre_arrow_ctx_reset(ctx);
  return ctx;
}
// Step function(s) for Lustre_arrow_ctx
void Lustre_arrow_step(_boolean i1,_boolean i2,_boolean *out,Lustre_arrow_ctx_type* ctx){  *out = ((ctx->_memory)? i1 : i2);
  ctx->_memory = _false;

} // End of Lustre_arrow_step

// Memory initialisation for Lustre_pre_ctx
void Lustre_pre_ctx_reset(Lustre_pre_ctx_type* ctx){
  //int _i;

}
// Memory allocation for Lustre_pre_ctx
Lustre_pre_ctx_type* Lustre_pre_ctx_new_ctx(){

   Lustre_pre_ctx_type* ctx = (Lustre_pre_ctx_type*)calloc(1, sizeof(Lustre_pre_ctx_type));
   // ctx->client_data = cdata;
   Lustre_pre_ctx_reset(ctx);
  return ctx;
}
// Step function(s) for Lustre_pre_ctx
void Lustre_pre_get(_boolean *out,Lustre_pre_ctx_type* ctx){
  *out = ctx->_memory;

} // End of Lustre_pre_get

void Lustre_pre_set(_boolean i1,Lustre_pre_ctx_type* ctx){
  ctx->_memory = i1;

} // End of Lustre_pre_set

// Memory initialisation for led_arduino_puzzle_ctx
void led_arduino_puzzle_ctx_reset(led_arduino_puzzle_ctx_type* ctx){
  //int _i;

    led_puzzle1_ctx_reset(&ctx->led_puzzle1_ctx_tab[0]);
    led_fedge_ctx_reset(&ctx->led_fedge_ctx_tab[0]);
    led_fedge_ctx_reset(&ctx->led_fedge_ctx_tab[1]);
}
// Memory allocation for led_arduino_puzzle_ctx
led_arduino_puzzle_ctx_type* led_arduino_puzzle_ctx_new_ctx(){

   led_arduino_puzzle_ctx_type* ctx = (led_arduino_puzzle_ctx_type*)calloc(1, sizeof(led_arduino_puzzle_ctx_type));
   // ctx->client_data = cdata;
   led_arduino_puzzle_ctx_reset(ctx);
  return ctx;
}
// Step function(s) for led_arduino_puzzle_ctx
void led_arduino_puzzle_step(_boolean red,_boolean blue,_boolean *led1,_boolean *led2,_boolean *led3,_boolean *led4,_boolean *led5,led_arduino_puzzle_ctx_type* ctx){   _boolean _split_2;
   _boolean _split_1;

  led_fedge_step(blue,&_split_2,&ctx->led_fedge_ctx_tab[0]); 
  led_fedge_step(red,&_split_1,&ctx->led_fedge_ctx_tab[1]); 
  led_puzzle1_step(_split_1,_split_2,led1,led2,led3,led4,led5,&ctx->led_puzzle1_ctx_tab[0]); 

} // End of led_arduino_puzzle_step

// Memory initialisation for led_fedge_ctx
void led_fedge_ctx_reset(led_fedge_ctx_type* ctx){
  //int _i;

    Lustre_pre_ctx_reset(&ctx->Lustre_pre_ctx_tab[0]);
    Lustre_arrow_ctx_reset(&ctx->Lustre_arrow_ctx_tab[0]);
}
// Memory allocation for led_fedge_ctx
led_fedge_ctx_type* led_fedge_ctx_new_ctx(){

   led_fedge_ctx_type* ctx = (led_fedge_ctx_type*)calloc(1, sizeof(led_fedge_ctx_type));
   // ctx->client_data = cdata;
   led_fedge_ctx_reset(ctx);
  return ctx;
}
// Step function(s) for led_fedge_ctx
void led_fedge_step(_boolean s,_boolean *res,led_fedge_ctx_type* ctx){   _boolean _split_5;
   _boolean _split_4;
   _boolean _split_3;

  Lustre_pre_get(&_split_3,&ctx->Lustre_pre_ctx_tab[0]); 
  _split_4 = ! s;
  _split_5 = _split_3 & _split_4;
  Lustre_pre_set(s,&ctx->Lustre_pre_ctx_tab[0]); 
  Lustre_arrow_step(_false,_split_5,res,&ctx->Lustre_arrow_ctx_tab[0]); 

} // End of led_fedge_step

// Memory initialisation for led_puzzle1_ctx
void led_puzzle1_ctx_reset(led_puzzle1_ctx_type* ctx){
  int _i;
  for (_i=0 ; _i<12 ; _i+=1){
    Lustre_pre_ctx_reset(&ctx->Lustre_pre_ctx_tab[_i]);
 }  for (_i=0 ; _i<5 ; _i+=1){
    Lustre_arrow_ctx_reset(&ctx->Lustre_arrow_ctx_tab[_i]);
 }
}
// Memory allocation for led_puzzle1_ctx
led_puzzle1_ctx_type* led_puzzle1_ctx_new_ctx(){

   led_puzzle1_ctx_type* ctx = (led_puzzle1_ctx_type*)calloc(1, sizeof(led_puzzle1_ctx_type));
   // ctx->client_data = cdata;
   led_puzzle1_ctx_reset(ctx);
  return ctx;
}
// Step function(s) for led_puzzle1_ctx
void led_puzzle1_step(_boolean red,_boolean blue,_boolean *led1,_boolean *led2,_boolean *led3,_boolean *led4,_boolean *led5,led_puzzle1_ctx_type* ctx){   _boolean _split_26;
   _boolean _split_25;
   _boolean _split_24;
   _boolean _split_23;
   _boolean _split_22;
   _boolean _split_21;
   _boolean _split_20;
   _boolean _split_19;
   _boolean _split_18;
   _boolean _split_17;
   _boolean _split_16;
   _boolean _split_15;
   _boolean _split_14;
   _boolean _split_13;
   _boolean _split_12;
   _boolean _split_11;
   _boolean _split_10;
   _boolean _split_9;
   _boolean _split_8;
   _boolean _split_7;
   _boolean _split_6;

  Lustre_pre_get(&_split_6,&ctx->Lustre_pre_ctx_tab[1]); 
  Lustre_pre_get(&_split_7,&ctx->Lustre_pre_ctx_tab[0]); 
   if (blue == _true) {
     _split_8 = _split_6;
   } else {
     _split_8 = _split_7;
   }
  Lustre_arrow_step(_false,_split_8,led1,&ctx->Lustre_arrow_ctx_tab[0]); 
  Lustre_pre_set(*led1,&ctx->Lustre_pre_ctx_tab[0]); 
  Lustre_pre_get(&_split_24,&ctx->Lustre_pre_ctx_tab[11]); 
  Lustre_pre_get(&_split_25,&ctx->Lustre_pre_ctx_tab[10]); 
   if (blue == _true) {
     _split_26 = _split_24;
   } else {
     _split_26 = _split_25;
   }
  Lustre_arrow_step(_false,_split_26,led5,&ctx->Lustre_arrow_ctx_tab[4]); 
  Lustre_pre_set(*led5,&ctx->Lustre_pre_ctx_tab[1]); 
  Lustre_pre_get(&_split_9,&ctx->Lustre_pre_ctx_tab[4]); 
  Lustre_pre_get(&_split_12,&ctx->Lustre_pre_ctx_tab[2]); 
  Lustre_pre_get(&_split_10,&ctx->Lustre_pre_ctx_tab[3]); 
  _split_11 = ! _split_10;
   if (red == _true) {
     _split_13 = _split_11;
   } else {
     _split_13 = _split_12;
   }
   if (blue == _true) {
     _split_14 = _split_9;
   } else {
     _split_14 = _split_13;
   }
  Lustre_arrow_step(_true,_split_14,led2,&ctx->Lustre_arrow_ctx_tab[1]); 
  Lustre_pre_set(*led2,&ctx->Lustre_pre_ctx_tab[2]); 
  Lustre_pre_set(*led2,&ctx->Lustre_pre_ctx_tab[3]); 
  Lustre_pre_set(*led1,&ctx->Lustre_pre_ctx_tab[4]); 
  Lustre_pre_get(&_split_15,&ctx->Lustre_pre_ctx_tab[6]); 
  Lustre_pre_get(&_split_16,&ctx->Lustre_pre_ctx_tab[5]); 
   if (blue == _true) {
     _split_17 = _split_15;
   } else {
     _split_17 = _split_16;
   }
  Lustre_arrow_step(_false,_split_17,led3,&ctx->Lustre_arrow_ctx_tab[2]); 
  Lustre_pre_set(*led3,&ctx->Lustre_pre_ctx_tab[5]); 
  Lustre_pre_set(*led2,&ctx->Lustre_pre_ctx_tab[6]); 
  Lustre_pre_get(&_split_18,&ctx->Lustre_pre_ctx_tab[9]); 
  Lustre_pre_get(&_split_21,&ctx->Lustre_pre_ctx_tab[7]); 
  Lustre_pre_get(&_split_19,&ctx->Lustre_pre_ctx_tab[8]); 
  _split_20 = ! _split_19;
   if (red == _true) {
     _split_22 = _split_20;
   } else {
     _split_22 = _split_21;
   }
   if (blue == _true) {
     _split_23 = _split_18;
   } else {
     _split_23 = _split_22;
   }
  Lustre_arrow_step(_false,_split_23,led4,&ctx->Lustre_arrow_ctx_tab[3]); 
  Lustre_pre_set(*led4,&ctx->Lustre_pre_ctx_tab[7]); 
  Lustre_pre_set(*led4,&ctx->Lustre_pre_ctx_tab[8]); 
  Lustre_pre_set(*led3,&ctx->Lustre_pre_ctx_tab[9]); 
  Lustre_pre_set(*led5,&ctx->Lustre_pre_ctx_tab[10]); 
  Lustre_pre_set(*led4,&ctx->Lustre_pre_ctx_tab[11]); 

} // End of led_puzzle1_step

